Subject: Re: [PATCH v3 net-next 2/2] netem: add cell concept to simulate special MAC behavior

From: Hagen Paul Pfeifer <[email-masked]>
Date: Thu, 01 Dec 2011 10:36:56 +0100

On Thu, 01 Dec 2011 10:01:48 +0100, Eric Dumazet wrote:

> Yes :)

damn!

> I want to be able to use netem on a 10Gigabit link, and simulate a 5ms

> delay. I already will hit the shared qdisc bottleneck, dont force me to

> use small packets !

No I don't want that. But with 10Gb/s links you will have packet

scheduling problems anyway - if you focus on an _accurate_ delay. A static

delay differs from rate shaping in use case. In the later we (and probably

you) want a exact/realistic spacing between packets.

Due to timer and scheduling granularity somewhere in between 1bit/s and

10Gb/s netem rate (and tbf) will not scale anymore. You will see burst and

inaccurate spacings, far away from what you want to emulate. For us we want

a realistic and clean behavior, if the result of the emulation is not

identical to the emulated link/device we cannot use it (some background

information). 

Anyway: I was not sure what solution you prefer - for us both are

identical. That's why I presented two solutions, so you can pick up the

favorite one. I will re-code the calculation using a reciprocal divide.

Thanks Eric!

Hagen